#!/usr/bin/env python
# **********************************************************************
#
# Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************

import sys, traceback, Ice

#Ice.loadSlice('-I. --all Hello.ice')
import Demo

def menu():
    print """
usage:
t: send greeting as twoway
s: shutdown server
x: exit
?: help
"""

def run(args, communicator):
    properties = communicator.getProperties()
    refProperty = 'Hello.Proxy'
    proxy = properties.getProperty(refProperty)
    if len(proxy) == 0:
        print args[0] + ": property `" + refProperty + "' not set"
        return False

    base = communicator.stringToProxy(proxy)
    twoway = Demo.HelloPrx.checkedCast(base.ice_twoway().ice_timeout(-1).ice_secure(False))
    if not twoway:
        print args[0] + ": invalid proxy"
        return False

    menu()

    c = None
    while c != 'x':
        try:
            c = raw_input("==> ")
            if c == 't':
                s = twoway.sayHello()
		print "received: " + str(s.x)
            elif c == 's':
                twoway.shutdown()
            elif c == 'x':
                pass # Nothing to do
            elif c == '?':
                menu()
            else:
                print "unknown command `" + c + "'"
                menu()
        except EOFError:
            break

    return True

communicator = None
try:
    properties = Ice.createProperties()
    properties.load("config")
    communicator = Ice.initializeWithProperties(sys.argv, properties)
    status = run(sys.argv, communicator)
except:
    traceback.print_exc()
    status = False

if communicator:
    try:
        communicator.destroy()
    except:
        traceback.print_exc()
        status = False

sys.exit(not status)
